commit 0a4550a326e4a299578df92933bcc82084d5b188
Author: Iain Sandoe <iain@sandoe.co.uk>
Date:   Wed Jan 18 23:25:36 2023 +0000

    Darwin, fixincludes: Handle Apple Blocks in objc/runtime.h.
    
    The macOS 13 SDK has unguarded Apple Blocks use in objc/runtime.h which
    causes most of the objective-c tests to fail.
    
    Signed-off-by: Iain Sandoe <iain@sandoe.co.uk>
    
    fixincludes/ChangeLog:
    
            * fixincl.x: Regenerate.
            * inclhack.def (darwin_objc_runtime_1): New hack.
            * tests/base/objc/runtime.h: New file.
    
    (cherry picked from commit 046dc9d0d4683bab99d28983d8841ba3c56ef744)

diff --git a/fixincludes/inclhack.def b/fixincludes/inclhack.def
index c6f3a44b0bd..6a2a1ac10bf 100644
--- a/fixincludes/inclhack.def
+++ b/fixincludes/inclhack.def
@@ -1451,6 +1451,41 @@ fix = {
   test_text = "typedef void (^os_trace_payload_t)(xpc_object_t xdict);";
 };
 
+/*
+ *  macOSX 13.0 SDK objc/runtime.h uses Apple Blocks extension without a guard.
+ */
+
+fix = {
+  hackname  = darwin_objc_runtime_1;
+  mach      = "*-*-darwin2*";
+  files     = objc/runtime.h;
+  select    =   <<- _EOSelect_
+	OBJC_EXPORT void.*
+	objc_enumerateClasses.*
+	.*
+	.*
+	.*
+	.*void \(\^ _Nonnull block.*
+	.*
+	.*
+	.*OBJC_REFINED_FOR_SWIFT.*
+	_EOSelect_;
+  c_fix     = format;
+  c_fix_arg = "#if __BLOCKS__\n%0\n#endif";
+  test_text = <<- _OBJC_RUNTIME_1
+OBJC_EXPORT void
+objc_enumerateClasses(const void * _Nullable image,
+                      const char * _Nullable namePrefix,
+                      Protocol * _Nullable conformingTo,
+                      Class _Nullable subclassing,
+                      void (^ _Nonnull block)(Class _Nonnull aClass, BOOL * _Nonnull stop)
+                      OBJC_NOESCAPE)
+OBJC_AVAILABLE(13.0, 16.0, 16.0, 9.0, 7.0)
+OBJC_REFINED_FOR_SWIFT;
+_OBJC_RUNTIME_1;
+};
+
+
 /*
  *  In Mac OS X 10.1[012] <os/trace.h>, need to guard users of
  *  os_trace_payload_t typedef, too.
